SystemOrganization addCategory: #'AL-Examples-Simple'!
SystemOrganization addCategory: #'AL-Examples-Amber'!

ALApplication subclass: #ALAmberApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Amber'!

!ALAmberApplication methodsFor: 'as yet unclassified' stamp: 'cwp 10/8/2012 00:02'!
initializeLocator
	| docroot |
	docroot := FSLocator imageDirectory / 'amber'.
	ALDirectoryScanner scan: docroot into: locator.
	
	locator 
		at: ALUrl root 
		put: (ALHtmlResource component: ALAmberIndexPage new)! !

ALApplication subclass: #ALExampleApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALExampleApplication methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2012 00:25'!
initializeLocator
	locator 
		at: ALPath root 
		put: ALExamplePage new asResource! !

Object subclass: #ALAjaxCounterEndpoint
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALAjaxCounterEndpoint methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 23:22'!
initialize
	count := 0! !

!ALAjaxCounterEndpoint methodsFor: 'rendering' stamp: 'cwp 8/1/2012 23:27'!
renderOn: json
	json object:
		[json name: 'count' value: count.
		json name: 'dec' navigate: [count := count - 1].
		json name: 'inc' navigate: [count := count + 1]]! !

Object subclass: #ALAmberIndexPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Amber'!

!ALAmberIndexPage methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2012 22:52'!
renderOn: html
	html html:
		[html head:
			[html title: 'Amber Index'].
		html body:
			[html p: 
				[html text: 'The Amber home page is at '.
				html a
					href: 'index.html';
					with: 'index.html']]]! !

Object subclass: #ALExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

ALExample subclass: #ALAjaxCounterExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 23:33'!
renderContentOn: html
	html a
		id: 'dec';
		class: 'action';
		href: '#';
		with: '--'.
	html span
		id: 'count';
		with: '0'.
	html a
		id: 'inc';
		class: 'action';
		href: '#';
		with: '++'.
	self renderScriptsOn: html! !

!ALAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2012 21:48'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script
		type: 'application/javascript';
		with: self script.
	html script
		type: 'application/javascript';
		with: 
			[html raw: 'var counter = new Counter("'.
			html text: (html context registerResource: self resource) printString.
			html raw: '"); counter.install("#count", "#dec", "#inc");' ]! !

!ALAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 23:03'!
renderStyleOn: html
	^ html style: '
#count {font-size: 36}
a.action {
  display: inline-block;
  margin: 10px;
  text-decoration: none;
'! !

!ALAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 23:20'!
resource
	^ ALJsonResource endpoint: ALAjaxCounterEndpoint new! !

!ALAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2012 21:56'!
script
	^ '
function Counter(url) {
  this.update(url);
};

Counter.prototype.install = function Counter_install(count, dec, inc) {
  var self = this;
  this.count = $(count);
  $(dec).click(function() {self.update(self.state.dec)});
  $(inc).click(function() {self.update(self.state.inc);});
};

Counter.prototype.update = function Counter_update(url) {
  var self = this;
  $.getJSON(url, function(json) {
    self.state = json;
    self.count.text(self.state.count);
  });
};
'! !

ALExample subclass: #ALCounterExample
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 22:57'!
initialize
	super initialize.
	count := 0! !

!ALCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 22:57'!
renderContentOn: html
	html a 
		class: 'action';
		navigate: [count := count - 1]; 
		with: '--'.
	html span
		class: 'counter';
		with: count asString.
	html a 
		class: 'action';
		navigate: [count := count + 1]; 
		with: '++'.! !

!ALCounterExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 22:36'!
renderStyleOn: html
	^ html style: '
.counter {font-size: 36}
a.action {
  display: inline-block;
  margin: 10px;
  text-decoration: none;
'! !

ALExample subclass: #ALEncodingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALEncodingExample methodsFor: 'rendering' stamp: 'cwp 8/11/2012 10:53'!
renderContentOn: html
	self renderEntitiesOn: html.
	self renderUnicodeOn: html! !

!ALEncodingExample methodsFor: 'rendering' stamp: 'cwp 8/11/2012 11:07'!
renderEntitiesOn: html
	html h2: 'HTML Entities'.
	html p with:
		[#('<' '"' '>' '&') do: 
			[:ea | html span class: 'entity'; with: ea]]! !

!ALEncodingExample methodsFor: 'rendering' stamp: 'cwp 8/11/2012 11:08'!
renderStyleOn: html
	html style: '
.entity {
	display: inline-block;
	margin-left: 8px;
	margin-right: 8 px;
}	
	
td {
    text-align: center;
    border: thin solid #aaa;
    width: 70px;
    height: 70px;
}

.glyph {
    display: block;
    font-size: 36px;;
}

.code {
    display: block;
    font-size: 10px;.
}
'! !

!ALEncodingExample methodsFor: 'rendering' stamp: 'cwp 8/11/2012 11:04'!
renderUnicodeOn: html
	| blank |
	html h2: 'Multibyte UTF-8'.
	blank := #(16r378 16r379 16r37F 16r380 16r381 16r382 16r383 16r38B 16r38D 16r3A2).
	html table: 
		[0 to: 15 do: 
			[:r | 
			html tr: 
				[16r37 to: 16r3F do: 
					[:c || code |
					code := c * 16 + r.
					html td: 
						[(blank includes: code) ifFalse: 
							[html span class: 'glyph'; with: 
								[html text: (Character value: code) asString].
								html span class: 'code'; with: 
									[html text: 'U+'.
									html text: (code printStringBase: 16 nDigits: 4)]]]]]]]! !

!ALExample methodsFor: 'converting' stamp: 'cwp 8/1/2012 22:17'!
asResource
	^ ALHtmlResource component: self! !

!ALExample methodsFor: 'rendering' stamp: 'cwp 8/1/2012 22:19'!
renderOn: html
	html h1: self title.
	self renderContentOn: html! !

!ALExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 22:19'!
renderStyleOn: html! !

!ALExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2012 22:30'!
title
	| in out |
	out := String new writing.
	in := self class name reading.
	in ++ 2.
	in do: 
		[:ch | 
		ch isUppercase ifTrue: [out space].
		out put: ch].
	^ out conclusion	! !

ALExample subclass: #ALFormExample
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALFormExample methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2012 12:37'!
initialize
	integer := 0! !

!ALFormExample methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2012 00:06'!
renderContentOn: html
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			callback: [:str | integer := str asNumber];
			with: [].
		html text: integer asWords]! !

!ALFormExample methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2012 13:23'!
renderStyleOn: html
	html style: 'input {margin-right: 20px}'! !

ALExample subclass: #ALStreamingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALStreamingExample methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2012 15:18'!
renderContentOn: html
	html ol:
		[1 to: 100000 do:
			[:i | 
			html li:
				[html text: i asWords]]]! !

Object subclass: #ALExamplePage
	instanceVariableNames: 'examples current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Examples-Simple'!

!ALExamplePage methodsFor: 'converting' stamp: 'cwp 7/22/2012 07:51'!
asResource
	^ ALHtmlResource component: self! !

!ALExamplePage methodsFor: 'initialize-release' stamp: 'cwp 9/13/2012 12:41'!
initialize
	examples := {
		'unicode' -> ALEncodingExample.
		'streaming' -> ALStreamingExample.
		'counter' -> ALCounterExample.
		'ajax counter' -> ALAjaxCounterExample.
		'form' -> ALFormExample.
	}.
	current := examples first value new.! !

!ALExamplePage methodsFor: 'rendering' stamp: 'cwp 8/1/2012 22:13'!
renderBodyOn: html
	html div
		class: 'navbar';
		with: [self renderNavBarOn: html].
	html div
		class: 'example';
		with: [current renderOn: html]! !

!ALExamplePage methodsFor: 'rendering' stamp: 'cwp 8/1/2012 23:43'!
renderNavBarOn: html
	html ul:
		[examples do:
			[:pair |
			html li:
				[html a
					navigate: [current := pair value new];
					with: pair key]]].! !

!ALExamplePage methodsFor: 'rendering' stamp: 'cwp 8/1/2012 22:41'!
renderOn: html
	html html: 
		[html head: 
			[html title: 'Altitude Examples'.
			self renderStylesOn: html].
		html body: [ self renderBodyOn: html ] ]! !

!ALExamplePage methodsFor: 'rendering' stamp: 'cwp 8/1/2012 22:21'!
renderStylesOn: html
	html style: [html text: self style].
	current renderStyleOn: html! !

!ALExamplePage methodsFor: 'rendering' stamp: 'cwp 8/1/2012 23:39'!
style
	^ '
div.navbar {
    position: absolute;
    left: 0;
    top: 0;
    bottom: 0;
    width: 200px;
}

div.navbar li {
    list-style-type: none;
}

div.navbar a {
    text-decoration: none;
}

div.example {
    position: absolute;
    top: 0;
    right: 0;
    left: 200px;
    bottom: 0;
}
'! !
